10 '**************************************************************************
20 '*                            PRGTIM.BAS                                  *
30 '*           BASIC source file for PRGTIM.EXE  (Revised 05/30/84)         *
40 '**************************************************************************
50 '*                                                                        *
60 '*    This program calculates amount of time spent by an individual using *
70 '* an application program, and then writes that information, along with   *
80 '* the date, & user's name, to a file, `PRGTIM.DTA'.  The file also shows *
90 '* how much of the use-time was for business purposes.                    *
100 '*                                                                        *
110 '*   This program works in conjunction with `TMSTRT.BAS,' as part of a    *
120 '* BATCH file, to create a record of computer use by various users.       *
130 '*                                                                        *
140 '*   The program `RPTUSE.BAS' will print out a REPORT using the data in   *
150 '* the file `PRGTIM.DTA' for documentation of PC use.                     *
160 '*                                                                        *
170 '*   This REVISION defaults to `BUSINESS USE' when data is entered, but   *
180 '* it will write the files EXACTLY as before, and it can be used with     *
190 '* PRGTIM.DTA files written with the previous version.                    *
200 '*                                                                        *
210 '*   PLEASE see `USE-TIME.DOC' for instructions on using this program     *
220 '*                                                                        *
230 '*       Program written by Steve Kent, Marin/Sonoma-PC User's Group      *
240 '*       CIS 72406,504                       v 1.2  /  05/30/84           *
250 '**************************************************************************
260 '
270 KEY OFF : CLS : DEFINT C,R
280 DEF SEG=&H40 : POKE &H17 , PEEK (&H17) OR 64 'Set for Capital letters
290 HRSTOP=VAL(MID$(TIME$,1,2)) : MINSTOP=VAL(MID$(TIME$,4,2))
300 STOPTIME = HRSTOP*60 + MINSTOP
310 OPEN "TMSTRT.DTA" FOR INPUT AS #1
320 INPUT #1, DAT$, STARTTIME$, STARTTIME
330 IF STOPTIME < STARTTIME THEN STOPTIME = STOPTIME + (24*60)
340 LOCATE 2,36 : COLOR 0,7: PRINT " "+DAT$+" ": COLOR 7,0
350 LOCATE 25,1: V$=" Please note: COMMAS are NOT permitted in data entries " :     PRINT SPACE$((80-LEN(V$))*.5); : COLOR 0,7: PRINT V$;: COLOR 7,0
360 GOSUB 820
370 LOCATE 18,10 : PRINT "Your NAME, INITIALS, or other ID (Max=11 char.): "
380 LOCATE 18,59: PRINT STRING$(11,"_"): LOCATE 18,58: INPUT " ",NM$
390 IF NM$="" THEN LOCATE 18,3: BEEP : PRINT SPACE$(74) : GOTO 370
400 IF LEN(NM$) > 11 THEN 410 ELSE 420
410 LOCATE 22,24: BEEP: PRINT "Too many characters.  Limit is 11" : GOSUB 800:      GOSUB 820 : GOTO 370
420 LOCATE 5,1 : V$=" NAME: " + NM$ +" ": PRINT SPACE$((80-LEN(V$))*.5);
430 COLOR 0,7 : PRINT V$ : COLOR 7,0 :LOCATE 18,3 :PRINT SPACE$(74)
440 LOCATE 18,11: PRINT "NAME of PROGRAM you were using (Max=12 char): "
450 LOCATE 18,57: PRINT STRING$(12,"_"): LOCATE 18,56: INPUT " ",PN$
460 IF PN$ ="" THEN LOCATE 18,3: BEEP : PRINT SPACE$(74) : GOTO 440
470 IF LEN(PN$) > 12 THEN 480 ELSE 490
480 BEEP : LOCATE 22,24: PRINT "Too many characters.  Limit is 12" : GOSUB 800:     GOSUB 820 : GOTO 440
490 LOCATE 8,1 : V$=" PROGRAM: " + PN$ +" ": PRINT SPACE$((80-LEN(V$))*.5);
500 COLOR 0,7 : PRINT V$ : COLOR 7,0 :LOCATE 20,3 :PRINT SPACE$(74)
510 LOCATE 18,7: PRINT "COMMENTS (Max=24 char.  Hit <enter> to SKIP): "
520 LOCATE 18,53: PRINT STRING$(24,"_"): LOCATE 18,52: INPUT " ",CM$
530 IF LEN(CM$) > 24 THEN 540 ELSE 550
540 BEEP: LOCATE 22,24: PRINT "Too many characters.  Limit is 24" : GOSUB 800:      GOSUB 820 : GOTO 510
550 LOCATE 11,1 : V$=" COMMENTS: " + CM$ +" ": PRINT SPACE$((80-LEN(V$))*.5);
560 COLOR 0,7 : PRINT V$ : COLOR 7,0 :LOCATE 20,3 :PRINT SPACE$(74)
570 ELAPSTIME = STOPTIME - STARTTIME : ELAPSHRS = ELAPSTIME \ 60 :                  XTRAMIN = ELAPSTIME MOD 60
580 ELAPSTIM$=STR$(ELAPSHRS) + " Hrs."+STR$(XTRAMIN) +" Min."
590 ELAPSTIME$=STR$(ELAPSHRS) + ":" + STR$(XTRAMIN)
600 LOCATE 15,1 :  V$="Elapsed time for " :  Y$=": "
610 PRINT SPACE$((80-LEN(V$+PN$+Y$+ELAPSTIM$))*.5);: COLOR 0,7:                     PRINT V$+PN$+Y$+ELAPSTIM$ : COLOR 7,0
620 LOCATE 18,3 : PRINT SPACE$(74)
630 LOCATE 25,5 : PRINT SPACE$(70);
640 LOCATE 17,14:PRINT "How much of this time was for NON-BUSINESS purposes?"
660 LOCATE 18,32 : PRINT "Hrs. <enter>" : LOCATE 18,50 : PRINT "Min. <enter>"
670 LOCATE 21,1 : V$="Hitting <enter> twice" : PRINT SPACE$((80-LEN(V$))*.5)+V$
680 LOCATE 22,1 : V$="credits ALL of the use-time" :                                PRINT SPACE$((80-LEN(V$))*.5)+V$
690 LOCATE 23,1 : V$="as `BUSINESS USE'" : PRINT SPACE$((80-LEN(V$))*.5)+V$
700 LOCATE 18,28 :INPUT" ",NONBH : LOCATE 18,46 : INPUT " ",NONBMIN
710 IF (NONBH*60+NONBMIN)>ELAPSTIME OR NONBMIN > 60 THEN 720 ELSE 740
720 LOCATE 19,27: BEEP : PRINT "Please redo last input...."
730 SOUND 32767,8: SOUND 32767,1: FOR R=17 TO 19: LOCATE R,1: PRINT SPACE$(79):     NEXT: GOTO 660
740 NONBSNS=NONBH*60+NONBMIN : BSNS=ELAPSTIME-NONBSNS
750 '
760 OPEN "PRGTIM.DTA" FOR APPEND AS #2
770 WRITE #2, DAT$, STARTTIME$, NM$, PN$, CM$, BSNS , NONBSNS
780 CLS : END: 'SYSTEM
790 '*********** SUBROUTINE: PAUSE AND ERASE LINES *************
800 SOUND 32767,16: SOUND 32767,1: FOR R=18 TO 22: LOCATE R,3:                      PRINT SPACE$(74):  NEXT: RETURN
810 '*********** SUBROUTINE: DRAWING BOX AROUND QUERIES *************
820 LOCATE 16,2:PRINT CHR$(218):FOR C=3 TO 77 : LOCATE 16,C:PRINT CHR$(196):        NEXT : LOCATE 16,78:PRINT CHR$(191)
830 FOR R=17 TO 18 : LOCATE R,2:PRINT CHR$(179): LOCATE R,78 : PRINT CHR$(179):     NEXT
840 LOCATE 19,2:PRINT CHR$(192):FOR C=3 TO 77 : LOCATE 19,C:PRINT CHR$(196):        NEXT : LOCATE 19,78:PRINT CHR$(217)
850 RETURN
